// internet.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <commctrl.h>
#include <windowsx.h>
#include <Wininet.h>
#include <stdio.h>
#include <wingdi.h>

#include "interpreteProxyServer.h"
#include "registre.h"

HINSTANCE hInst;

LRESULT CALLBACK MainProc (HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK ProxyProc (HWND,UINT,WPARAM,LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	hInst = hInstance;
	LoadLibrary("riched32.dll");
	InitCommonControls();
	DialogBox(hInst,MAKEINTRESOURCE(IDD_MAIN),NULL,(DLGPROC) MainProc);
	return 0;
}

#define INTERNET_CONNECTION_CONFIGURED	0x40
#define INTERNET_CONNECTION_OFFLINE		0x20
#define INTERNET_RAS_INSTALLED			0x10


void ChangeState (HWND hDlg,int idc,int num)
{
	static HBITMAP hImage[3];
	static BOOL init = FALSE;

	if (!init)
	{
		hImage[0] = LoadBitmap(hInst,MAKEINTRESOURCE (IDB_BITMAP_FALSE));
		hImage[1] = LoadBitmap(hInst,MAKEINTRESOURCE (IDB_BITMAP_TRUE));
		hImage[2] = LoadBitmap(hInst,MAKEINTRESOURCE (IDB_BITMAP_UNKNOWN));
		init = TRUE;
	}

	SendDlgItemMessage(hDlg,idc,STM_SETIMAGE,(WPARAM) IMAGE_BITMAP,(LPARAM) hImage[num]);
}


// Mesage handler for about box.
LRESULT CALLBACK MainProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static char editText[1024];
	static WPARAM id;
	static BOOL modeAuto;

	static BOOL VCONNECTION = 2;				
	static BOOL VINTERNET_CONNECTION_CONFIGURED = 2;
	static BOOL VINTERNET_CONNECTION_LAN = 2;
	static BOOL VINTERNET_CONNECTION_MODEM = 2;
	static BOOL VINTERNET_CONNECTION_MODEM_BUSY = 2;
	static BOOL VINTERNET_CONNECTION_OFFLINE = 2;
	static BOOL VINTERNET_CONNECTION_PROXY = 2;
	static BOOL VINTERNET_RAS_INSTALLED = 2;
	static BOOL VPARAM = 2;

	switch (message)
	{
		case WM_INITDIALOG:
			modeAuto = FALSE;
			return TRUE;

		case WM_TIMER:
			SendMessage(hDlg,WM_COMMAND,IDC_BUTTON_TEST,0);
			break;
	
		case WM_CTLCOLORSTATIC:
			{
			HDC hdcStatic = (HDC) wParam;    // handle to display context 
			HWND hwndStatic = (HWND) lParam; // handle to static control 
			COLORREF color[3];

			color[0] = RGB(255,0,0);
			color[1] = RGB(0,128,64);
			color[2] = RGB(128,128,255);

			int result = 0; // 0 rien, 1 rouge , 2 vert , 3 bleu 

			if (hwndStatic == GetDlgItem (hDlg,IDC_STATIC_I_INTERNET_CONNECTION_CONFIGURED)) result = VINTERNET_CONNECTION_CONFIGURED+1;
			if (hwndStatic == GetDlgItem (hDlg,IDC_STATIC_I_INTERNET_CONNECTION_LAN)) result = VINTERNET_CONNECTION_LAN+1;
			if (hwndStatic == GetDlgItem (hDlg,IDC_STATIC_I_INTERNET_CONNECTION_MODEM)) result = VINTERNET_CONNECTION_MODEM+1;
			if (hwndStatic == GetDlgItem (hDlg,IDC_STATIC_I_INTERNET_CONNECTION_MODEM_BUSY)) result = VINTERNET_CONNECTION_MODEM_BUSY+1;
			if (hwndStatic == GetDlgItem (hDlg,IDC_STATIC_I_INTERNET_CONNECTION_OFFLINE)) result = VINTERNET_CONNECTION_OFFLINE+1;
			if (hwndStatic == GetDlgItem (hDlg,IDC_STATIC_I_INTERNET_CONNECTION_PROXY)) result = VINTERNET_CONNECTION_PROXY+1;
			if (hwndStatic == GetDlgItem (hDlg,IDC_STATIC_I_INTERNET_RAS_INSTALLED )) result = VINTERNET_RAS_INSTALLED+1;

			if (result)
			{
				HGDIOBJ hBrush = GetStockObject(NULL_BRUSH);
				SetTextColor (hdcStatic,color[result-1]);
				SetBkColor(hdcStatic,GetSysColor(COLOR_BTNFACE));
				return (HRESULT)hBrush;
			}
			}
		    break;

		case WM_COMMAND:
			id = LOWORD(wParam);
			switch (id)
			{
				case IDOK:
					EndDialog(hDlg, LOWORD(wParam));
					return TRUE;

				case IDC_BUTTON_TEST:
				{
					DWORD result;
					int nbFind = 0;
					char temp[1024];
					strcpy(editText,"");

					VCONNECTION = InternetGetConnectedState(&result,0);
					ChangeState(hDlg,IDC_STATIC_CONNECTION,VCONNECTION);
					
					int nbTrue = 0;
					DWORD copyResult = result;
					for (;copyResult;copyResult>>=1)
					{
						nbTrue += copyResult&1;
					}
					sprintf(temp,"%ld",result);
					Static_SetText(GetDlgItem (hDlg,IDC_STATIC_VALUE),temp);

					VINTERNET_CONNECTION_CONFIGURED = (result & INTERNET_CONNECTION_CONFIGURED) == INTERNET_CONNECTION_CONFIGURED;
					ChangeState(hDlg,IDC_STATIC_INTERNET_CONNECTION_CONFIGURED,VINTERNET_CONNECTION_CONFIGURED);
					nbFind +=VINTERNET_CONNECTION_CONFIGURED;

					VINTERNET_CONNECTION_LAN = (result & INTERNET_CONNECTION_LAN) == INTERNET_CONNECTION_LAN;
					ChangeState(hDlg,IDC_STATIC_INTERNET_CONNECTION_LAN,VINTERNET_CONNECTION_LAN);
					nbFind +=VINTERNET_CONNECTION_LAN;

					VINTERNET_CONNECTION_MODEM = (result & INTERNET_CONNECTION_MODEM) == INTERNET_CONNECTION_MODEM;
					ChangeState(hDlg,IDC_STATIC_INTERNET_CONNECTION_MODEM,VINTERNET_CONNECTION_MODEM);
					nbFind +=VINTERNET_CONNECTION_MODEM;

					VINTERNET_CONNECTION_MODEM_BUSY = (result & INTERNET_CONNECTION_MODEM_BUSY) == INTERNET_CONNECTION_MODEM_BUSY,
					ChangeState(hDlg,IDC_STATIC_INTERNET_CONNECTION_MODEM_BUSY,VINTERNET_CONNECTION_MODEM_BUSY);
					nbFind +=VINTERNET_CONNECTION_MODEM_BUSY;

					VINTERNET_CONNECTION_OFFLINE = (result & INTERNET_CONNECTION_OFFLINE) == INTERNET_CONNECTION_OFFLINE;
					ChangeState(hDlg,IDC_STATIC_INTERNET_CONNECTION_OFFLINE,VINTERNET_CONNECTION_OFFLINE);
					nbFind +=VINTERNET_CONNECTION_OFFLINE;
					
					VINTERNET_CONNECTION_PROXY = (result & INTERNET_CONNECTION_PROXY) == INTERNET_CONNECTION_PROXY;
					ChangeState(hDlg,IDC_STATIC_INTERNET_CONNECTION_PROXY,VINTERNET_CONNECTION_PROXY);
					nbFind +=VINTERNET_CONNECTION_PROXY;

					VINTERNET_RAS_INSTALLED = (result & INTERNET_RAS_INSTALLED) == INTERNET_RAS_INSTALLED;
					ChangeState(hDlg,IDC_STATIC_INTERNET_RAS_INSTALLED,VINTERNET_RAS_INSTALLED);
					nbFind +=VINTERNET_RAS_INSTALLED;

					VPARAM = nbFind == nbTrue;
					ChangeState(hDlg,IDC_STATIC_PARAM,VPARAM);

					InvalidateRect(hDlg,NULL,FALSE);
				}
				break;

				case IDC_BUTTON_AUTO:
					if (!modeAuto) 
					{
						Button_SetText(GetDlgItem (hDlg,id),"Stop");
						SetTimer(hDlg,1,250,NULL);
					}
					else 
					{
						Button_SetText(GetDlgItem (hDlg,id),"Auto");
						KillTimer(hDlg,1);
					}

					modeAuto = !modeAuto;
					break;

				case IDC_BUTTON_INFO_PROXY:
					DialogBox(hInst,MAKEINTRESOURCE(IDD_DIALOG_PROXY),NULL,(DLGPROC) ProxyProc);
					break;
				}
			break;
	}
    return FALSE;
}



LRESULT CALLBACK ProxyProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static WPARAM id;

	switch (message)
	{
		case WM_INITDIALOG:
			{
				char editText[1024];
				CRegistre registre("Software\\Microsoft\\Windows\\CurrentVersion","Internet Settings");
				registre.GetParamString("ProxyServer",editText);

				Edit_SetText(GetDlgItem (hDlg,IDC_EDIT_PROXYSERVER),editText);
				PostMessage(hDlg,WM_COMMAND,IDC_BUTTON_TEST,0);
			}
			return TRUE;

			
		case WM_COMMAND:
			id = LOWORD(wParam);
			switch (id)
			{
				case IDC_BUTTON_TEST:
					{
						char editText[1024];
						Edit_GetText(GetDlgItem (hDlg,IDC_EDIT_PROXYSERVER),editText,1024);

						CInterpreteProxyServer proxy(editText);
						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_SCHEME_FTP),proxy.ftp.scheme);
						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_PROXY_FTP),proxy.ftp.proxy);
						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_PORT_FTP),proxy.ftp.port);

						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_SCHEME_GOPHER),proxy.gopher.scheme);
						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_PROXY_GOPHER),proxy.gopher.proxy);
						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_PORT_GOPHER),proxy.gopher.port);

						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_SCHEME_HTTP),proxy.http.scheme);
						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_PROXY_HTTP),proxy.http.proxy);
						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_PORT_HTTP),proxy.http.port);

						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_SCHEME_HTTPS),proxy.https.scheme);
						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_PROXY_HTTPS),proxy.https.proxy);
						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_PORT_HTTPS),proxy.https.port);
					
						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_SCHEME_SOCKS),proxy.socks.scheme);
						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_PROXY_SOCKS),proxy.socks.proxy);
						Static_SetText(GetDlgItem (hDlg,IDC_STATIC_PORT_SOCKS),proxy.socks.port);					
					}
					break;

				case IDB_BUTTON_QUITER:
					EndDialog(hDlg, TRUE);
					return TRUE;
			}
			break;
	}
    return FALSE;
}