#include "stdafx.h"
#include "InterpreteProxyServer.h"
#include "stdio.h"


CInterpreteProxyServer::CInterpreteProxyServer(char *source) : CToken (source)
{

	ZeroMemory(&m_proxy,sizeof(TProxyServer));
	memcpy(&ftp,&m_proxy,sizeof(TProxyServer));
	memcpy(&gopher,&m_proxy,sizeof(TProxyServer));
	memcpy(&http,&m_proxy,sizeof(TProxyServer));
	memcpy(&https,&m_proxy,sizeof(TProxyServer));
	memcpy(&socks,&m_proxy,sizeof(TProxyServer));

	do
	{
		ZeroMemory(&m_proxy,sizeof(TProxyServer));
		if (!GramMain()) return;

		// deplacement dans le proxy type
		TProxyServer *current = NULL; // non reconnue
		BOOL allTheSame = FALSE;

		if (strcmp(m_proxy.protocol,""))
		{
			if (!strcmp(m_proxy.protocol,"ftp")) current = &ftp;
			else if (!strcmp(m_proxy.protocol,"gopher")) current = &gopher;
			else if (!strcmp(m_proxy.protocol,"http")) current = &http;
			else if (!strcmp(m_proxy.protocol,"https")) current = &https;
			else if (!strcmp(m_proxy.protocol,"socks")) current = &socks;
		}   else allTheSame = TRUE; // tous les memes !

		if (current) memcpy(current,&m_proxy,sizeof(TProxyServer));
		else ; // pas reconnue
		if (allTheSame)
		{
			memcpy(&ftp,&m_proxy,sizeof(TProxyServer));
			memcpy(&gopher,&m_proxy,sizeof(TProxyServer));
			memcpy(&http,&m_proxy,sizeof(TProxyServer));
			memcpy(&https,&m_proxy,sizeof(TProxyServer));
			memcpy(&socks,&m_proxy,sizeof(TProxyServer));
		}


	} while (sep==';');
}

CInterpreteProxyServer::~CInterpreteProxyServer()
{
}


// [<protocol>=][<scheme>://]<proxy>[:<port>][; ...]

BOOL CInterpreteProxyServer::GramMain()
{
	if (!Find("=:;")) return FALSE;
	switch(sep)
	{
		case EOF:
		case ';': // <proxy> soit just un separateur
			if (!strcmp(result,"")) return GramMain();
			strcpy(m_proxy.proxy,result);
			return TRUE;

		case '=': // <protocol>=[<scheme>://]<proxy>[:<port>] 
			strcpy(m_proxy.protocol,result);
			return GramTScheme();

		case ':': // [<scheme>:]//<proxy>[:<port>] ou <proxy>[:<port>] ==> scheme ou proxy
			strcpy(m_unknown,result);
			return GramScheme();
	}
	return FALSE;
}


// [<scheme>://]<proxy>[:<port>]

BOOL CInterpreteProxyServer::GramTScheme()
{
	if (!Find(":;")) return FALSE;
	switch(sep)
	{
		case EOF:
		case ';': // <proxy> soit just un separateur
			strcpy(m_proxy.proxy,result);
			return TRUE;

		case ':':
			strcpy(m_unknown,result);
			return GramScheme();
	}
	return FALSE;
}


// <scheme>://<proxy>[:<port>] ou <proxy>[:<port>] ==> <scheme> ou <proxy>
// rq.: m_unknow, contien le dernier token valide

BOOL CInterpreteProxyServer::GramScheme()
{
	if (!Find("/;")) return FALSE;

	switch(sep)
	{
		case EOF:
		case ';': // <proxy>:port
			strcpy(m_proxy.proxy,m_unknown);
			strcpy(m_proxy.port,result);
			return TRUE;

		case '/': // <scheme>://<proxy>[:<port>] 
			strcpy(m_proxy.scheme,m_unknown);
			if (!Find("/")) return FALSE;
			if (!Find(":;")) return FALSE;
			switch (sep)
			{
				case EOF:
				case ';': // <proxy>
					strcpy(m_proxy.proxy,result);
					return TRUE;

				case ':': // <proxy>:<port>
					strcpy(m_proxy.proxy,result);
					if (!Find("/;")) return FALSE;
					switch(sep)
					{
						case EOF:
						case ';': // <port>
							strcpy(m_proxy.port,result);
							return TRUE;
					}
					return FALSE;
			}
	}
	return FALSE;
}

