// Registre.cpp: implementation of the Registre class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "registre.h"
#include "resource.h"
#include <stdio.h>

#define MAX_STRING 50

/* ---------------------------------------------------------------------------------------------
   Constructeur du gestionaire de registre (dans "Software")
--------------------------------------------------------------------------------------------- */

CRegistre::CRegistre(char *nameKey)
{
	m_nameKey = new char[MAX_PATH];
	m_pathKey = new char[MAX_PATH];

	strcpy (m_nameKey,nameKey);
	strcpy (m_pathKey,"Software");
	Init();
}

CRegistre::CRegistre(char *pathKey,char *nameKey)
{
	m_nameKey = new char[MAX_PATH];
	m_pathKey = new char[MAX_PATH];

	strcpy (m_nameKey,nameKey);
	strcpy (m_pathKey,pathKey);
	Init();
}

CRegistre::~CRegistre()
{
	delete m_nameKey;
	delete m_pathKey;
}


/* ---------------------------------------------------------------------------------------------
   Initialisation: cree une clef pour le nom: nameKey donnee 
--------------------------------------------------------------------------------------------- */

void CRegistre::Init()
{
	HKEY hKey ,hKeySub; 

	if (RegOpenKeyExA( HKEY_CURRENT_USER, m_pathKey , 0 , KEY_WRITE, &hKey)!=ERROR_SUCCESS) 
		::MessageBoxA(0,"Read operation from register key impossible","Error / Register",MB_OK);
	
	if (RegCreateKeyA( hKey, m_nameKey ,&hKeySub) != ERROR_SUCCESS)	
		::MessageBoxA(0,"Write operation to register key impossible","Error / Register",MB_OK);
		
	RegCloseKey (hKey) ;
}


/* ---------------------------------------------------------------------------------------------
   Donne la valeur du param dans la base de registre ==> result
--------------------------------------------------------------------------------------------- */

BOOL CRegistre::GetParamString(char *param , char *result)
{
	HKEY hKey ; 
	DWORD dwSize=128;
	ULONG uType = REG_SZ ;
	char path[MAX_PATH];

	sprintf(path,"%s\\%s",m_pathKey,m_nameKey);

	if (RegOpenKeyExA( HKEY_CURRENT_USER, path,0,KEY_QUERY_VALUE,&hKey) != ERROR_SUCCESS) return FALSE;

	if (RegQueryValueExA (hKey, param,NULL, &uType, (unsigned char *)result, &dwSize) != ERROR_SUCCESS) return FALSE;
	RegCloseKey (hKey) ;
	return TRUE;
}


BOOL CRegistre::GetParamInt(char *param,int *result)
{
	HKEY hKey ; 
	DWORD dwSize=sizeof(REG_DWORD);
	ULONG uType = REG_DWORD;;
	char path[MAX_PATH];
	int val;

	sprintf(path,"%s\\%s",m_pathKey,m_nameKey);

	if (RegOpenKeyExA( HKEY_CURRENT_USER, path,0,KEY_QUERY_VALUE ,&hKey) != ERROR_SUCCESS) return FALSE;
	if (val= RegQueryValueExA (hKey, param,NULL, &uType, (unsigned char *)result, &dwSize) != ERROR_SUCCESS) return FALSE;
	
	RegCloseKey (hKey) ;
	return TRUE;
}


/* ---------------------------------------------------------------------------------------------
   Place la valeur value dans le parametre param de la base de registre selectionner par nameKey
--------------------------------------------------------------------------------------------- */

BOOL CRegistre::SetParamString(char *param,char *value)
{
	HKEY hKey ; 
	char path[MAX_STRING];

	sprintf(path,"%s\\%s",m_pathKey,m_nameKey);
	
	if (RegOpenKeyExA  (HKEY_CURRENT_USER, path,0,KEY_SET_VALUE,&hKey) != ERROR_SUCCESS) return FALSE;
    if (RegSetValueExA (hKey, param,NULL, REG_SZ , (unsigned char *)value, strlen(value)) != ERROR_SUCCESS) return FALSE;
	RegCloseKey (hKey) ;
	return TRUE;
}


BOOL CRegistre::SetParamInt(char *param,int value)
{
	HKEY hKey ; 
	char path[MAX_PATH];

	sprintf(path,"%s\\%s",m_pathKey,m_nameKey);
	
	if (RegOpenKeyExA( HKEY_CURRENT_USER, path,0,KEY_SET_VALUE,&hKey) != ERROR_SUCCESS) return FALSE;
    if (RegSetValueExA (hKey, param,NULL, REG_DWORD , (unsigned char *)&value, sizeof(REG_DWORD)) != ERROR_SUCCESS) return FALSE;
	RegCloseKey (hKey) ;
	return TRUE;
}
